//+------------------------------------------------------------------+
//|                                           MultiCurrency MACD.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.ru/"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  Blue
#property  indicator_color2  Yellow
#property  indicator_color3  Red
#property  indicator_color4  Green
#property  indicator_color5  DarkOrchid
#property  indicator_color6  PaleGreen
#property  indicator_color7  Magenta
//int indicator_color3;
#define EURUSD 0
#define GBPUSD 1
#define AUDUSD 2
#define USDJPY 3
#define USDCHF 4
#define USDCAD 5
#define EURJPY 6
#define EURGBP 7
#define EURCHF 8
#define EURAUD 9
#define GBPJPY 10
#define GBPCHF 11

#define USD 0
#define EUR 1
#define GBP 2
#define CHF 3
#define CAD 4
#define AUD 5
#define JPY 6
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];
double     ind_buffer5[];
double     ind_buffer6[];
double     ind_buffer7[];
double     temp;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1);
   SetIndexDrawBegin(1,SignalSMA);
   //IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+5);
//---- indicator buffers mapping
  SetIndexBuffer(0,ind_buffer1);
  SetIndexBuffer(1,ind_buffer2);
  SetIndexBuffer(2,ind_buffer3);
  SetIndexBuffer(3,ind_buffer4);
  SetIndexBuffer(4,ind_buffer5);
  SetIndexBuffer(5,ind_buffer6);
  SetIndexBuffer(6,ind_buffer7);
   SetIndexLabel(0,"EURUSD");
   SetIndexLabel(1,"GBPUSD");
   SetIndexLabel(2,"AUDUSD");
   SetIndexLabel(3,"USDJPY");
   SetIndexLabel(4,"USDCHF");
   SetIndexLabel(5,"USDCAD");
   SetIndexLabel(6,"USDX");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("-USD-7-QIANGRUO");
//---- initialization done
  //
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit,error;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=limit; i>=0; i--)
      {
      ind_buffer1[i]=-10000*iMACD("EURUSD",0,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,i);//-iMA("EURUSD",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      //ind_buffer1[i]=-10000*(iMA("EURUSD",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("EURUSD",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      ind_buffer2[i]=-10000*(iMA("GBPUSD",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("GBPUSD",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      error=GetLastError();
      if (error!=0) Print(" Error code ",error, "   i=",i,"  Bars=",Bars,"  counted_bars=",counted_bars);
      ind_buffer3[i]=-10000*(iMA("AUDUSD",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("AUDUSD",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      ind_buffer4[i]=100*(iMA("USDJPY",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("USDJPY",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i))/200;
      ind_buffer5[i]=10000*(iMA("USDCHF",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("USDCHF",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      ind_buffer6[i]=10000*(iMA("USDCAD",0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA("USDCAD",0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i));
      ind_buffer7[i]=(ind_buffer1[i]+ind_buffer2[i]+ind_buffer3[i]+ind_buffer4[i]+ind_buffer5[i]+ind_buffer6[i])/6;
      }
      //---- signal line counted in the 2-nd buffer  
//---- done
   return(0);
  }